/*
 * captchamanager.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include <QDir>
#include <QImage>
#include <QFileDialog>
#include <QMessageBox>
#include <QString>

#include "captchamanager.h"

using namespace kms;

kms::CaptchaManager::CaptchaManager(QWidget *parent) : QWidget(parent) {

	// Sets up the ui
	_ui.setupUi(this);

	// Connects the okPushButton
	connect(_ui.okPushButton, SIGNAL(clicked()), this, SLOT(slot_okPushButtonClicked()));

}

kms::CaptchaManager::~CaptchaManager() {

	// Does nothing...

}

void kms::CaptchaManager::setCaptcha(const QByteArray &data) {

	QPixmap qPixmap;
	qPixmap.loadFromData(data);
	_ui.imageLabel->setPixmap(qPixmap);

}

void kms::CaptchaManager::setVisible(bool value) {

	// Shows this QWidget
	QWidget::setVisible(value);

	// Focuses the inputLineEdit
	if(value == true) {
		_ui.inputLineEdit->clear();
		_ui.inputLineEdit->setFocus();
	}

}

QString kms::CaptchaManager::getLastCode() {

	return _ui.inputLineEdit->text();

}

void kms::CaptchaManager::slot_okPushButtonClicked() {

	// Hides this QWidget
	this->setVisible(false);

}

