/*
 * defaultiostrategy.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_DEFAULT_IO_STRATEGY_H
#define KMS_DEFAULT_IO_STRATEGY_H

#include <QByteArray>
#include <QHash>
#include <QList>
#include <QString>

#include "iostrategy.h"
#include "captchamanager.h"

namespace kms {

	class DefaultIOStrategy : public IOStrategy {

		public:
			DefaultIOStrategy();
			~DefaultIOStrategy();

			QList< QPair<QString, QString> > getInputs(const QList< QHash<QString, QString> > &inputs, bool *ok = 0);
			QPair<QString, QString> getInput(const QHash<QString, QString> &input, bool *ok = 0);
			QString getCaptchaInput(const QHash<QString, QString> &input, const QByteArray &data, bool *ok = 0);
			void showMessage(const QString &message);

		private:
			CaptchaManager *_captchaManager;

	};

};

#endif
