/*
 * cookie.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include <QStringList>

#include "cookie.h"

using namespace kms;

kms::Cookie::Cookie()
{
	// Do nothing...
}

kms::Cookie::Cookie(const QString &cookie)
{
	setCookie(cookie);
}

kms::Cookie::~Cookie()
{
	// Do nothing...
}

QString kms::Cookie::toQString() const
{
	return _cookie;
}

void kms::Cookie::setCookie(const QString &cookie)
{
	_cookie = cookie;
	_setFields();
}

QString kms::Cookie::getName() const
{
	return _name;
}

QString kms::Cookie::getContent() const
{
	return _content;
}

/*
QString kms::Cookie::getDomain() const
{
	return _domain;
}

QString kms::Cookie::getPath() const
{
	return _path;
}

QString kms::Cookie::getExpires() const
{
	return _expires;
}
*/

void kms::Cookie::setName(QString name)
{
	_name = name;
}

void kms::Cookie::setContent(QString content)
{
	_content = content;
}

/*
void kms::Cookie::setDomain(QString domain)
{
	_domain = domain;
}

void kms::Cookie::setPath(QString path)
{
	_path = path;
}

void kms::Cookie::setExpires(QString expires)
{
	_expires = expires;
}
*/

void kms::Cookie::_setFields()
{
	QStringList chuncks = _cookie.split(";");

	QString chunck = _cookie;
	_name = chuncks[0].trimmed();
	_name.chop(_name.size() - _name.indexOf("=") );
	_content = chuncks[0];
	_content.remove(0, _content.indexOf("=") + 1);
}
