/*
 * cookie.h
 *
 * $author Pietro Spinella (pietro.spinella@gmail.com)
 * $license GPLv3
 */

#ifndef KMS_COOKIE_H
#define KMS_COOKIE_H

#include <QString>

namespace kms
{
	class Cookie
	{
		public:
			Cookie();
			Cookie(const QString &cookie);
			~Cookie();

			QString toQString() const;
			void setCookie(const QString &cookie);

			QString getName() const;
			QString getContent() const;
			// QString getDomain() const;
			// QString getPath() const;
			// QString getExpires() const;

			void setName(QString name);
			void setContent(QString content);
			// void setDomain(QString domain);
			// void setPath(QString path);
			// void setExpires(QString expires);

		private:
			QString _cookie;

			QString _name;
			QString _content;
			// QString _domain;
			// QString _path;
			// QString _expires;

			void _setFields();
	};
};

#endif
