/*
 * cookiemanager.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include "cookiemanager.h"

using namespace kms;

kms::CookieManager::CookieManager() {
	_cookies = new QList<Cookie>;
}

kms::CookieManager::~CookieManager() {
	delete _cookies;
}

void kms::CookieManager::attachCookies(QHttpRequestHeader *header) {

	QString cookieQString;
	bool flag = false;
	QList<Cookie> cookies = getCookies();
	for(QList<Cookie>::iterator i = cookies.begin(); i != cookies.end(); i++) {
		QString name = (*i).getName();
		cookieQString.append((*i).getName() + "=" + (*i).getContent() + "; ");
		flag = true;
	}

	if(flag == true) {
		cookieQString.chop(2);
	}

	if(cookieQString != "") {
		header->setValue("Cookie", cookieQString);
	}

}

void kms::CookieManager::clearCookies() {
	delete _cookies;
	_cookies = new QList<Cookie>;
}

QList<Cookie> kms::CookieManager::getCookies() const {
	return *_cookies;
}

Cookie kms::CookieManager::getCookie(QString name) const {

	Cookie result;

	for(QList<Cookie>::iterator i = _cookies->begin(); i != _cookies->end(); i++) {
		if((*i).getName() == name) {
			result = *i;
			break;
		}
	}

	return result;

}

void kms::CookieManager::setCookie(QString cookie) {

	Cookie theCookie(cookie);
	QString name = theCookie.getName();

	bool flag = false;

	for(QList<Cookie>::iterator i = _cookies->begin(); i != _cookies->end(); i++) {
		if((*i).getName() == name) {
			(*i).setCookie(theCookie.toQString());
			flag = true;
			break;
		}
	}

	if(flag == false) {
		_cookies->append(theCookie);
	}

}
