/*
 * cookiemanager.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_COOKIE_MANAGER_H
#define KMS_COOKIE_MANAGER_H

#include <QHttpRequestHeader>
#include <QList>
#include <QString>

#include "cookie.h"

namespace kms {

	class CookieManager {

		public:
			CookieManager();
			~CookieManager();

			void attachCookies(QHttpRequestHeader *header);
			void clearCookies();
			QList<Cookie> getCookies() const;
			Cookie getCookie(QString name) const;
			void setCookie(QString cookie);

		private:
			QList<Cookie> *_cookies;

	};

};

#endif
