/*
 * enhancedqhttp.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_ENHANCEDQHTTP_H
#define KMS_ENHANCEDQHTTP_H

#include <QHttp>

#include "cookiemanager.h"

namespace kms {

	class EnhancedQHttp : public QHttp {

		Q_OBJECT

		public:
			EnhancedQHttp();
			~EnhancedQHttp();

			CookieManager *getCookieManager();

		private:
			CookieManager *_cookieManager;

			int requestPerformedFlag;

		signals:
			void requestPerformed(QByteArray &data);

		private slots:
			void manageResponse(const QHttpResponseHeader &responseHeader);
			void manageDone(bool error);

	};

};

#endif
