/*
 * iostrategy.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_IOSTRATEGY_H
#define KMS_IOSTRATEGY_H

#include <QByteArray>
#include <QHash>
#include <QList>
#include <QString>

namespace kms {

	class IOStrategy {

		public:
			virtual ~IOStrategy();

			virtual QList< QPair<QString, QString> > getInputs(const QList< QHash<QString, QString> > &inputs, bool *ok = 0) = 0;
			virtual QPair<QString, QString> getInput(const QHash<QString, QString> &input, bool *ok = 0) = 0;
			virtual QString getCaptchaInput(const QHash<QString, QString> &input, const QByteArray &data, bool *ok = 0) = 0;

			virtual void showMessage(const QString &message) = 0;

	};

};

#endif

