/*
 * action.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#include "action.h"

using namespace kms;

kms::Action::Action() {
	_id = "";
	_type = "";
	_httpRequest = 0;
	_checkHttpRequest = 0;
	_askCaptchaCode = 0;
}

kms::Action::~Action() {
	if(_httpRequest != 0) {
		delete _httpRequest;
	}
	if(_checkHttpRequest != 0) {
		delete _checkHttpRequest;
	}
	if(_askCaptchaCode != 0) {
		delete _askCaptchaCode;
	}
}

const QString &kms::Action::getId() const {
	return _id;
}

const QString &kms::Action::getType() const {
	return _type;
}

const HttpRequest *kms::Action::getHttpRequest() const {
	return _httpRequest;
}

const CheckHttpRequest *kms::Action::getCheckHttpRequest() const {
	return _checkHttpRequest;
}

const AskCaptchaCode *kms::Action::getAskCaptchaCode() const {
	return _askCaptchaCode;
}

void kms::Action::setId(const QString &id) {
	_id = id;
}

void kms::Action::setType(const QString &type) {
	_type = type;
}

void kms::Action::setHttpRequest(const HttpRequest *httpRequest) {
	_httpRequest = (HttpRequest *) httpRequest;
}

void kms::Action::setCheckHttpRequest(const CheckHttpRequest *checkHttpRequest) {
	_checkHttpRequest = (CheckHttpRequest *) checkHttpRequest;
}

void kms::Action::setAskCaptchaCode(const AskCaptchaCode *askCaptchaCode) {
	_askCaptchaCode = (AskCaptchaCode *) askCaptchaCode;
}
