/*
 * action.h
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#ifndef KMS_ACTION_H
#define KMS_ACTION_H

#include <QString>

#include "httprequest.h"
#include "checkhttprequest.h"
#include "askcaptchacode.h"

namespace kms {

	class Action {

		public:
			Action();
			~Action();

			const QString &getId() const;
			const QString &getType() const;

			const HttpRequest *getHttpRequest() const;
			const CheckHttpRequest *getCheckHttpRequest() const;
			const AskCaptchaCode *getAskCaptchaCode() const;

			void setId(const QString &id);
			void setType(const QString &type);

			void setHttpRequest(const HttpRequest *httpRequest);
			void setCheckHttpRequest(const CheckHttpRequest *checkHttpRequest);
			void setAskCaptchaCode(const AskCaptchaCode *askCaptchaCode);

		private:
			QString _id;
			QString _type;

			HttpRequest *_httpRequest;
			CheckHttpRequest *_checkHttpRequest;
			AskCaptchaCode *_askCaptchaCode;

	};

};

#endif
