/*
 * checkhttprequest.h
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#ifndef KMS_CHECK_HTTP_REQUEST_H
#define KMS_CHECK_HTTP_REQUEST_H

#include <QString>

namespace kms {

	class CheckHttpRequest {

		public:
			CheckHttpRequest();
			~CheckHttpRequest();

			const QString &getHttpRequest() const;
			const QString &getContainsRegex() const;
			const QString &getOnTrueOutput() const;
			const QString &getOnFalseOutput() const;
			const QString &getOnTrue() const;
			const QString &getOnFalse() const;

			void setHttpRequest(const QString &httpRequest);
			void setContainsRegex(const QString &containsRegex);
			void setOnTrueOutput(const QString &onTrueOutput);
			void setOnFalseOutput(const QString &onFalseOutput);
			void setOnTrue(const QString &onTrue);
			void setOnFalse(const QString &onFalse);

		private:
			QString _httpRequest;
			QString _containsRegex;
			QString _onTrueOutput;
			QString _onFalseOutput;
			QString _onTrue;
			QString _onFalse;

	};

};

#endif
