/*
 * input.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#include "input.h"

using namespace kms;

kms::Input::Input() {
	_id = "";
	_content = "";
	_type = "";
	_regex = "";
	_name = "";
	_defaultValue = "";
	_tmpValue = ""; // TMP!
}

kms::Input::~Input() {
	// Does nothing...
}

const QString &kms::Input::getId() const {
	return _id;
}

const QString &kms::Input::getContent() const {
	return _content;
}

const QString &kms::Input::getType() const {
	return _type;
}

const QString &kms::Input::getRegex() const {
	return _regex;
}

const QString &kms::Input::getName() const {
	return _name;
}

const QString &kms::Input::getDefaultValue() const {
	return _defaultValue;
}

void kms::Input::setId(const QString &id) {
	_id = id;
}

void kms::Input::setContent(const QString &content) {
	_content = content;
}

void kms::Input::setType(const QString &type) {
	_type = type;
}

void kms::Input::setRegex(const QString &regex) {
	_regex = regex;
}

void kms::Input::setName(const QString &name) {
	_name = name;
}

void kms::Input::setDefaultValue(const QString &defaultValue) {
	_defaultValue = defaultValue;
}

// TMP! (BEGIN)

const QString &kms::Input::getTmpValue() const {
	return _tmpValue;
}

void kms::Input::setTmpValue(const QString &tmpValue) {
	_tmpValue = tmpValue;
}

// TMP! (END)
