/*
 * input.h
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#ifndef KMS_INPUT_H
#define KMS_INPUT_H

#include <QString>

namespace kms {

	class Input {

		public:
			Input();
			~Input();

			const QString &getId() const;
			const QString &getContent() const;
			const QString &getType() const;
			const QString &getRegex() const;
			const QString &getName() const;
			const QString &getDefaultValue() const;

			void setId(const QString &id);
			void setContent(const QString &content);
			void setType(const QString &type);
			void setRegex(const QString &regex);
			void setName(const QString &name);
			void setDefaultValue(const QString &defaultValue);

			const QString &getTmpValue() const;        // TMP!
			void setTmpValue(const QString &tmpValue); // TMP!

		private:
			QString _id;
			QString _content;
			QString _type;
			QString _regex;
			QString _name;
			QString _defaultValue;

			QString _tmpValue; // TMP!
	};

};

#endif
