/*
 * kmsroot.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#include "kmsroot.h"

using namespace kms;

kms::KmsRoot::KmsRoot() {
	_version = "";
	_texts = new Texts;
	_services = new Services;
}

kms::KmsRoot::~KmsRoot() {
	if(_texts != 0) {
		delete _texts;
	}
	if(_services != 0) {
		delete _services;
	}
}

const QString &kms::KmsRoot::getVersion() const {
	return _version;
}

const Texts *kms::KmsRoot::getTexts() const {
	return _texts;
}

const Services *kms::KmsRoot::getServices() const {
	return _services;
}

void kms::KmsRoot::setVersion(const QString &version) {
	_version = version;
}

void kms::KmsRoot::setTexts(const Texts *texts) {
	_texts = (Texts *) texts;
}

void kms::KmsRoot::setServices(const Services *services) {
	_services = (Services *) services;
}
