/*
 * kmsroot.h
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#ifndef KMS_KMS_ROOT_H
#define KMS_KMS_ROOT_H

#include <QString>

#include "texts.h"
#include "services.h"

namespace kms {

	class KmsRoot {

		public:
			KmsRoot();
			~KmsRoot();

			const QString &getVersion() const;

			const Texts *getTexts() const;
			const Services *getServices() const;

			void setVersion(const QString &version);

			void setTexts(const Texts *texts);
			void setServices(const Services *services);

		private:
			QString _version;

			Texts *_texts;
			Services *_services;

	};

};

#endif
