/*
 * sequence.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#include "sequence.h"

using namespace kms;

kms::Sequence::Sequence() {
	_id = "";
	_usedInputs = new UsedInputs;
	_usedActions = new UsedActions;
}

kms::Sequence::~Sequence() {
	if(_usedInputs != 0) {
		delete _usedInputs;
	}
	if(_usedActions != 0) {
		delete _usedActions;
	}
}

const QString &kms::Sequence::getId() const {
	return _id;
}

const UsedInputs *kms::Sequence::getUsedInputs() const {
	return _usedInputs;
}

const UsedActions *kms::Sequence::getUsedActions() const {
	return _usedActions;
}

void kms::Sequence::setId(const QString &id) {
	_id = id;
}

void kms::Sequence::setUsedInputs(const UsedInputs *usedInputs) {
	_usedInputs = (UsedInputs *) usedInputs;
}

void kms::Sequence::setUsedActions(const UsedActions *usedActions) {
	_usedActions = (UsedActions *) usedActions;
}
