/*
 * sequence.h
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#ifndef KMS_SEQUENCE_H
#define KMS_SEQUENCE_H

#include <QList>
#include <QString>

#include "usedinputs.h"
#include "usedactions.h"

namespace kms {

	class Sequence {

		public:
			Sequence();
			~Sequence();

			const QString &getId() const;

			const UsedInputs *getUsedInputs() const;
			const UsedActions *getUsedActions() const;

			void setId(const QString &id);

			void setUsedInputs(const UsedInputs *usedInputs);
			void setUsedActions(const UsedActions *usedActions);

		private:
			QString _id;

			UsedInputs *_usedInputs;
			UsedActions *_usedActions;

	};

};

#endif
