/*
 * sequences.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#include "sequences.h"

using namespace kms;

kms::Sequences::Sequences() {
	_sequenceList = new QList<Sequence *>;
}

kms::Sequences::~Sequences() {
	if(_sequenceList != 0) {
		for(int i = _sequenceList->size(); i > 0; i--) {
			delete _sequenceList->takeAt(0);
		}
		delete _sequenceList;
	}
}

const QList<Sequence *> *kms::Sequences::getSequenceList() const {
	return _sequenceList;
}

void kms::Sequences::setSequenceList(const QList<Sequence *> *sequenceList) {
	_sequenceList = (QList<Sequence *> *) sequenceList;
}
