/*
 * service.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#include "service.h"

using namespace kms;

kms::Service::Service() {
	_id = "";
	_name = "";
	_icon = "";
	_description = "";
	_version = "";
	_author = "";
	_enabled = "";
	_texts = new Texts;
	_inputs = new Inputs;
	_outputs = new Outputs;
	_actions = new Actions;
	_sequences = new Sequences;
}

kms::Service::~Service() {
	if(_texts != 0) {
		delete _texts;
	}
	if(_inputs != 0) {
		delete _inputs;
	}
	if(_outputs != 0) {
		delete _outputs;
	}
	if(_actions != 0) {
		delete _actions;
	}
	if(_sequences != 0) {
		delete _sequences;
	}
}

const QString &kms::Service::getId() const {
	return _id;
}

const QString &kms::Service::getName() const {
	return _name;
}

const QString &kms::Service::getIcon() const {
	return _icon;
}

const QString &kms::Service::getDescription() const {
	return _description;
}

const QString &kms::Service::getVersion() const {
	return _version;
}

const QString &kms::Service::getAuthor() const {
	return _author;
}

const QString &kms::Service::getEnabled() const {
	return _enabled;
}

const Texts *kms::Service::getTexts() const {
	return _texts;
}

const Actions *kms::Service::getActions() const {
	return _actions;
}

const Inputs *kms::Service::getInputs() const {
	return _inputs;
}

const Outputs *kms::Service::getOutputs() const {
	return _outputs;
}

const Sequences *kms::Service::getSequences() const {
	return _sequences;
}

void kms::Service::setId(const QString &id) {
	_id = id;
}

void kms::Service::setName(const QString &name) {
	_name = name;
}

void kms::Service::setIcon(const QString &icon) {
	_icon = icon;
}

void kms::Service::setDescription(const QString &description) {
	_description = description;
}

void kms::Service::setVersion(const QString &version) {
	_version = version;
}

void kms::Service::setAuthor(const QString &author) {
	_author = author;
}

void kms::Service::setEnabled(const QString &enabled) {
	_enabled = enabled;
}

void kms::Service::setTexts(const Texts *texts) {
	_texts = (Texts *) texts;
}

void kms::Service::setInputs(const Inputs *inputs) {
	_inputs = (Inputs *) inputs;
}

void kms::Service::setOutputs(const Outputs *outputs) {
	_outputs = (Outputs *) outputs;
}

void kms::Service::setActions(const Actions *actions) {
	_actions = (Actions *) actions;
}

void kms::Service::setSequences(const Sequences *sequences) {
	_sequences = (Sequences *) sequences;
}
