/*
 * text.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#include "text.h"

using namespace kms;

kms::Text::Text() {
	_id = "";
	_valueList = new QList<Value *>;
}

kms::Text::~Text() {
	if(_valueList != 0) {
		for(int i = _valueList->size(); i > 0; i--) {
			delete _valueList->takeAt(0);
		}
		delete _valueList;
	}
}

const QString &kms::Text::getId() const {
	return _id;
}

const QList<Value *> *kms::Text::getValueList() const {
	return _valueList;
}

void kms::Text::setId(const QString &id) {
	_id = id;
}

void kms::Text::setValueList(const QList<Value *> *valueList) {
	_valueList = (QList<Value *> *) valueList;
}
