/*
 * texts.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#include "texts.h"

using namespace kms;

kms::Texts::Texts() {
	_defaultLanguage = "";
	_textList = new QList<Text *>;
}

kms::Texts::~Texts() {
	if(_textList != 0) {
		for(int i = _textList->size(); i > 0; i--) {
			delete _textList->takeAt(0);
		}
		delete _textList;
	}
}

const QString &kms::Texts::getDefaultLanguage() const {
	return _defaultLanguage;
}

const QList<Text *> *kms::Texts::getTextList() const {
	return _textList;
}

void kms::Texts::setDefaultLanguage(const QString &defaultLanguage) {
	_defaultLanguage = defaultLanguage;
}

void kms::Texts::setTextList(const QList<Text *> *textList) {
	_textList = (QList<Text *> *) textList;
}
