/*
 * texts.h
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#ifndef KMS_TEXTS_H
#define KMS_TEXTS_H

#include <QList>
#include <QString>

#include "text.h"

namespace kms {

	class Texts {

		public:
			Texts();
			~Texts();

			const QString &getDefaultLanguage() const;

			const QList<Text *> *getTextList() const;

			void setDefaultLanguage(const QString &defaultLanguage);

			void setTextList(const QList<Text *> *textList);

		private:
			QString _defaultLanguage;

			QList<Text *> *_textList;

	};

};

#endif
