/*
 * usedinputs.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail@com)
 * $license GPLv3
 */

#include "usedinputs.h"

using namespace kms;

kms::UsedInputs::UsedInputs() {
	_usedInputList = new QList<UsedInput *>;
}

kms::UsedInputs::~UsedInputs() {
	if(_usedInputList != 0) {
		for(int i = _usedInputList->size(); i > 0; i--) {
			delete _usedInputList->takeAt(0);
		}
		delete _usedInputList;
	}
}

const QList<UsedInput *> *kms::UsedInputs::getUsedInputList() const {
	return _usedInputList;
}

void kms::UsedInputs::setUsedInputList(const QList<UsedInput *> *usedInputList) {
	_usedInputList = (QList<UsedInput *> *) usedInputList;
}
