/*
 * account.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include "account.h"

using namespace kms;

kms::Account::Account() {
	// Does nothing...
}

kms::Account::Account(const QString &name, const QString &username, const QString &password, const Provider *provider) : _name(name), _username(username), _password(password), _provider((Provider *) provider) {
	// Does nothing...
}

kms::Account::Account(const Account &account) : _name(account._name), _username(account._username), _password(account._password), _provider(account._provider) {
	// Does nothing...
}

kms::Account::~Account() {
	// Does nothing...
}

QString kms::Account::getName() const {
	return _name;
}

QString kms::Account::getUsername() const {
	return _username;
}

QString kms::Account::getPassword() const {
	return _password;
}

Provider *kms::Account::getProvider() const {
	return _provider;
}

void kms::Account::setName(const QString &name) {
	_name = name;
}

void kms::Account::setUsername(const QString &username) {
	_username = username;
}

void kms::Account::setPassword(const QString &password) {
	_password = password;
}

void kms::Account::setProvider(const Provider *provider) {
	_provider = (Provider *) provider;
}

QString kms::Account::toQString() {
	return QString("[name=" + _name + ", username=" + _username + ", password=" + _password + ", provider=" + _provider->toQString() + "]");
}
