/*
 * account.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_ACCOUNT_H
#define KMS_ACCOUNT_H

#include <QString>

#include "providers/provider.h"

namespace kms {

	class Provider;

	class Account {

		public:
			Account();
			Account(const Account &account);
			Account(const QString &name, const QString &username, const QString &password, const Provider *provider);
			~Account();

			QString getName() const;
			QString getUsername() const;
			QString getPassword() const;
			Provider *getProvider() const;

			void setName(const QString &name);
			void setUsername(const QString &username);
			void setPassword(const QString &password);
			void setProvider(const Provider *provider);

			QString toQString();

		private:
			QString _name;
			QString _username;
			QString _password;
			Provider *_provider;

	};

};

#endif
