/*
 * accountitemdelegate.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_ACCOUNT_ITEM_DELEGATE_H
#define KMS_ACCOUNT_ITEM_DELEGATE_H

#include <QAbstractItemModel>
#include <QItemDelegate>
#include <QModelIndex>
#include <QStyleOptionViewItem>
#include <QWidget>

#include "mainwindow.h"

namespace kms {

	class AccountItemDelegate : public QItemDelegate {

		public:

			AccountItemDelegate(QObject *parent = 0);

			QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const;
			void setEditorData(QWidget *editor, const QModelIndex &index) const;
			void setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const;

		private:

			MainWindow *_parent;

	};

};

#endif
