/*
 * indexbookitemdelegate.cpp
 *
 * $author Pietro Spinella (scrockman@gmail.com)
 */

#include "indexbookitemdelegate.h"
using namespace kms;

kms::IndexBookItemDelegate::IndexBookItemDelegate(QObject *parent) : QItemDelegate(parent) {

	// Nothing...

}

QWidget *kms::IndexBookItemDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem & /* option */, const QModelIndex &index) const {

	QComboBox *comboBox;
	QLineEdit *lineEdit;

	switch(index.column()) {
		case 0:
		case 1:
			lineEdit = new QLineEdit(parent);
			return lineEdit;
		case 2:
			comboBox = new QComboBox(parent);
			comboBox->addItem(QIcon(QString::fromUtf8(":/images/images/account.png")), QApplication::translate("MainWindow", "<None>", 0, QApplication::UnicodeUTF8) );
/*			comboBox->addItem(QIcon(QString::fromUtf8(":/images/images/account.png")), QApplication::translate("MainWindow", "Generic (alice.it)", 0, QApplication::UnicodeUTF8) );
			comboBox->addItem(QIcon(QString::fromUtf8(":/images/images/account.png")), QApplication::translate("MainWindow", "Generic (tin.it)", 0, QApplication::UnicodeUTF8) );
			comboBox->addItem(QIcon(QString::fromUtf8(":/images/images/account.png")), QApplication::translate("MainWindow", "Generic (vodafone.it MMS)", 0, QApplication::UnicodeUTF8) );
			comboBox->addItem(QIcon(QString::fromUtf8(":/images/images/account.png")), QApplication::translate("MainWindow", "Generic (vodafone.it SMS)", 0, QApplication::UnicodeUTF8) );
*/			return comboBox;

	}

//	connect(comboBox, SIGNAL(activated(int)), this, SLOT(emitCommitData()));

}

void kms::IndexBookItemDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const {

	QComboBox *comboBox;
	QLineEdit *lineEdit;
	QString value;
	int pos;

	switch(index.column()) {
		case 0:
		case 1:
			lineEdit = qobject_cast<QLineEdit *>(editor);
			value = index.model()->data(index, Qt::DisplayRole).toString();
			lineEdit->setText(value);
			break;
		case 2:
			comboBox = qobject_cast<QComboBox *>(editor);
			pos = comboBox->findText(index.model()->data(index).toString(), Qt::MatchExactly);
			comboBox->setCurrentIndex(pos);
			break;
		default:
			break;
	}

}

void kms::IndexBookItemDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const {

	QComboBox *comboBox;
	QLineEdit *lineEdit;

	switch(index.column()) {
		case 0:
		case 1:
			lineEdit = qobject_cast<QLineEdit *>(editor);
			model->setData(index, lineEdit->text());
			break;
		case 2:
			comboBox = qobject_cast<QComboBox *>(editor);
			model->setData(index, comboBox->currentText());
		default:
			break;
	}

}

void kms::IndexBookItemDelegate::emitCommitData() {

	emit commitData(qobject_cast<QWidget *>(sender()));

}
