/*
 * job.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include "job.h"

using namespace kms;

kms::Job::Job() : _servant(NULL) {
	// Does nothing...
}

kms::Job::Job(const Job &job) : _account((Account *) job._account), _message(job._message) {
	_servant = job._servant;
}

kms::Job::Job(const Account *account, const Message &message) : _account((Account *) account), _message(message), _servant(NULL) {
	// Does nothing...
}

kms::Job::~Job() {
/*
	if(_servant != NULL) {
		delete _servant;
	}
*/
}

const Job &kms::Job::operator=(const Job& job) {
	this->_account = job._account;
	this->_message = job._message;
	this->_servant = job._servant;
	return *this;
}

Account *kms::Job::getAccount() const {
	return _account;
}

Message kms::Job::getMessage() const {
	return _message;
}

void kms::Job::setAccount(const Account *account) {
	_account = (Account *) account;
}

void kms::Job::setMessage(const Message &message) {
	_message = message;
}

void kms::Job::sendMessage(MainWindow *mainWindow) {
	_servant = _account->getProvider()->createServant(mainWindow);
	_servant->sendMessage(_account, _message);
}

QString kms::Job::toQString() {
	return QString("[account=" + _account->toQString() + ", message=" + _message.toQString() + "]");
}
