/*
 * job.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_JOB_H
#define KMS_JOB_H

#include "account.h"
#include "message.h"
#include "providers/servant.h"

#include "mainwindow.h"

namespace kms {
class Account;
class MainWindow;
class Servant;
	class Job {

		public:
			Job();
			Job(const Job &job);
			Job(const Account *account, const Message &message);
			~Job();

			const Job &operator=(const Job& job);

			Account *getAccount() const;
			Message getMessage() const;

			void setAccount(const Account *account);
			void setMessage(const Message &message);

			void sendMessage(MainWindow *mainWindow);

			QString toQString();

		private:
			Account *_account;
			Message _message;
			Servant *_servant;

	};

};

#endif
