/*
 * message.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include "message.h"

using namespace kms;

kms::Message::Message() {
	// Does nothing...
}

kms::Message::Message(const Message &message) : _sender(message._sender), _recipient(message._recipient), _subject(message._subject), _text(message._text) {
	// Does nothing...
}

kms::Message::Message(const QString &sender, const QString &recipient, const QString &subject, const QString &text) {
	_sender = sender;
	_recipient = recipient;
	_subject = subject;
	_text = text;
}

kms::Message::~Message() {
	// Does nothing...
}

QString kms::Message::getSender() const {
	return _sender;
}

QString kms::Message::getRecipient() const {
	return _recipient;
}

QString kms::Message::getSubject() const {
	return _subject;
}

QString kms::Message::getText() const {
	return _text;
}

void kms::Message::setSender(const QString &sender) {
	_sender = sender;
}

void kms::Message::setRecipient(const QString &recipient) {
	_recipient = recipient;
}

void kms::Message::setSubject(const QString &subject) {
	_subject = subject;
}

void kms::Message::setText(const QString &text) {
	_text = text;
}

QString kms::Message::toQString() {
	return QString("[sender=" + _sender + ", recipient=" + _recipient + ", subject=" + _subject + ", text=" + _text + "]");
}
