/*
 * message.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_MESSAGE_H
#define KMS_MESSAGE_H

#include <QString>

namespace kms {

	class Message {

		public:
			Message();
			Message(const Message &message);
			Message(const QString &sender, const QString &recipient, const QString &subject, const QString &text);
			~Message();

			QString getSender() const;
			QString getRecipient() const;
			QString getSubject() const;
			QString getText() const;

			void setSender(const QString &sender);
			void setRecipient(const QString &recipient);
			void setSubject(const QString &subject);
			void setText(const QString &text);

			QString toQString();

		private:
			QString _sender;
			QString _recipient;
			QString _subject;
			QString _text;

	};

};

#endif
