/*
 * aliceitsms.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include <QRegExp>
#include <QString>

	#include <QDir>
	#include <QInputDialog>

#include "providers/aliceitsms.h"

using namespace kms;

kms::AliceItSms::AliceItSms() {

	setName(QString("alice.it sms"));

// DEF	setAcceptsSender(false);
	setAcceptsRecipient(true);
// DEF	setAcceptsSubject(false);
	setAcceptsText(true);

// DEF	setMaxSenderLenght(-1);
// DEF	setMaxRecipientLenght(-1);
// DEF	setMaxSubjectLenght(-1);
// DEF	setMaxTextLenght(-1);

// DEF	setSenderRegExp(QRegExp(".*"));
	setRecipientRegExp(QRegExp("[1-9]\\d{9}"));	// "(\\+|00)?[1-9]\\d*"
// DEF	setSubjectRegExp(QRegExp(".*"));
// DEF	setTextRegExp(QRegExp(".*"));

}

kms::AliceItSms::~AliceItSms() {
	// Does nothing...
}

Servant *kms::AliceItSms::createServant(MainWindow *mainWindow) {
	return new AliceItSmsServant(mainWindow);
}






kms::AliceItSmsServant::AliceItSmsServant(MainWindow *mainWindow) : Servant(mainWindow), _requestId(0) {

//	_qBuffer = new QBuffer(this);
//	_qBuffer->open(QBuffer::ReadWrite);
//	_mainWindow->debugTextEdit->setVisible(true);

	connect(qHttp_, SIGNAL(responseHeaderReceived(const QHttpResponseHeader &)), this, SLOT(_slot_ResponseHeaderReceived(const QHttpResponseHeader &)));
//	connect(qHttp_, SIGNAL(requestFinished(int, bool)), this, SLOT(_slot_requestFinished(int, bool)));
	connect(qHttp_, SIGNAL(done(bool)), this, SLOT(_slot_done(bool)));
//	connect(_qBuffer, SIGNAL(readyRead()), this, SLOT(_slot_qBufferReadyRead()));
//	connect(qHttp_, SIGNAL(responseHeaderReceived(const QHttpResponseHeader &)), _mainWindow->getCaptchaManager(), SLOT(show()));
//	_mainWindow->getCaptchaManager()->setVisible(true);

	step = 1;
	_cookieManager = new CookieManager;


}

kms::AliceItSmsServant::~AliceItSmsServant() {
	// Does nothing...
//	_qBuffer->close();
//	delete _qBuffer;
	disconnect(qHttp_, 0, 0, 0);
	delete _cookieManager;
}

void kms::AliceItSmsServant::run() {
	_send();
}

void kms::AliceItSmsServant::_send() {

	// NON ANCORA USATE!!!
	QString username = account_->getUsername();
	QString password = account_->getPassword();
	QString receiver = message_.getRecipient();
	QString text = message_.getText();

	if(step == 1) {
		qDebug("[DEBUG] AliceItSms - 1");
		QHttpRequestHeader header("POST", "/aap/validatecredential");
		qHttp_->setHost("authsrs.alice.it");
		header.setValue("Host", "authsrs.alice.it");
		header.setValue("Content-Type","application/x-www-form-urlencoded");
		header.setValue("Accept", "text/html, */*");
		header.setValue("Accept-Encoding", "identity");
		header.setValue("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Avant Browser; Avant Browser; .NET CLR 1.1.4322; .NET CLR 2.0.50727)");
		header.setValue("Referer", "http://pf.rossoalice.alice.it");
		header.setValue("Connection", "keep-alive");
		QStringList usernameParts = account_->getUsername().split("@");
		qHttp_->request(header, QByteArray(QString("usernameDisplay="+usernameParts[0]+"&dominio=@"+usernameParts[0]+"&password="+account_->getPassword()+"&login="+usernameParts[0]+"@"+usernameParts[1]+"&pwd="+account_->getPassword()+"&channel=hp_alice&servizio=mail&msisdn="+usernameParts[0]+"&username="+account_->getUsername()+"&user="+account_->getUsername()+"&a3aid=na&a3afep=http://portale.rossoalice.alice.it/ps/ManageCodError.do?code=470&channel=mail_alice&DOMAIN=&PASS="+account_->getPassword()+"").toUtf8()));
		return;
	}

	if(step == 2) {
		qDebug("[DEBUG] AliceItSms - 2");
		QHttpRequestHeader header("GET", "/aap/serviceforwarder?sf_dest=ibox_inviosms");
		qHttp_->setHost("auth.rossoalice.alice.it");
		header.setValue("Host", "auth.rossoalice.alice.it");
		header.setValue("Content-Type", "application/x-www-form-urlencoded");
		_attachCookies(&header);
		qHttp_->request(header);
		return;
	}

	if(step == 3) {
		qDebug("[DEBUG] AliceItSms - 3");
		QHttpRequestHeader header("GET", "/alice/jsp/SMS/composer.jsp?ID_Field=0&ID_Value=0&id_clickto=0&dummy=dummy");
		qHttp_->setHost("webloginmobile.rossoalice.alice.it");
		header.setValue("Host", "webloginmobile.rossoalice.alice.it");
		_attachCookies(&header);
		qHttp_->request(header);
		return;
	}

	if(step == 4) {   // post incompleto ?!
		qDebug("[DEBUG] AliceItSms - 4");
		QHttpRequestHeader header("POST", "/alice/jsp/SMS/CheckDest.jsp");
		qHttp_->setHost("webloginmobile.rossoalice.alice.it");
		header.setValue("Host", "webloginmobile.rossoalice.alice.it");
		header.setValue("Content-Type", "application/x-www-form-urlencoded");
		header.setValue("Accept", "text/html, */*");
		header.setValue("Accept-Encoding", "identity");
		header.setValue("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Avant Browser; Avant Browser; .NET CLR 1.1.4322; .NET CLR 2.0.50727)");
		header.setValue("Referer", "http://webloginmobile.rossoalice.alice.it/alice/jsp/SMS/Composer.jsp?ID_Field=0&ID_Value=0&id_clickto=0&dummy=dummy");
		header.setValue("Connection", "keep-alive");
		_attachCookies(&header);
		qHttp_->request(header, QByteArray(QString("SUNRISE=00D4Kzo5hXUz0BPXqCF75Yv1llw09MvdUoarhg8KyESZbule2edair+WEl19pqibgsMqU2ibW28gtT63D7vsdMQvJl+gOR2ZZ0LkPVb8SfBV5+kLGcaQR2xY2M6pJHmJiFtLrincjqnXaO9vUqtS9vQ0IQ7p5O6g36gcK7KvDxOm2MHu8KoXT2jISOm").toUtf8()));
		return;
	}

	if(step==5) {
		qDebug("[DEBUG] AliceItSms - 5");
		QHttpRequestHeader header("GET", "/alice/jsp/EwsJCaptcha.jpg");
		qHttp_->setHost("webloginmobile.rossoalice.alice.it");
		header.setValue("Host", "webloginmobile.rossoalice.alice.it");
		header.setValue("Accept", "text/html, */*");
		header.setValue("Accept-Encoding", "identity");
		header.setValue("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Avant Browser; Avant Browser; .NET CLR 1.1.4322; .NET CLR 2.0.50727)");
		header.setValue("Referer", "http://webloginmobile.rossoalice.alice.it/alice/jsp/SMS/inviaSms.jsp");
		header.setValue("Connection", "keep-alive");
		_attachCookies(&header);
		qHttp_->request(header/*, qBuffer*/);       // Settare il buffer!!!
		return;
	}

	if(step==6) {			// CAPTCHA!
		qDebug("[DEBUG] AliceItSms - 6");
		QHttpRequestHeader header("POST", "/alice/jsp/SMS/inviaSms.jsp");
		qHttp_->setHost("webloginmobile.rossoalice.alice.it");
		header.setValue("Host", "webloginmobile.rossoalice.alice.it");
		header.setValue("Content-Type", "application/x-www-form-urlencoded");
		header.setValue("Accept", "text/html, */*");
		header.setValue("Accept-Encoding", "identity");
		header.setValue("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Avant Browser; Avant Browser; .NET CLR 1.1.4322; .NET CLR 2.0.50727)");
		header.setValue("Referer", "http://webloginmobile.rossoalice.alice.it/alice/jsp/SMS/inviaSms.jsp");
		header.setValue("Connection", "keep-alive");
		_attachCookies(&header);
		qHttp_->request(header, QByteArray(QString("nonInRubrica="+message_.getRecipient()+"&nonInviati=&captchafield=" + _captchaText + "&DEST="+message_.getRecipient()+"&ABGDEST=&TYPE=smsp&ABG_NOME_LISTA=&NOME_LISTA=&SHORT_MESSAGE="+message_.getText()+"&SHORT_MESSAGE2="+message_.getText()+"&INVIA_SUBITO=true&GIORNO=9/3/2007&ORE=09&MINUTI=00").toUtf8()));
		return;
	}

	// The end is reached?
	if(step == 6) {
		_cookieManager->clearCookies();
		return;
	}

}

void kms::AliceItSmsServant::_slot_ResponseHeaderReceived(const QHttpResponseHeader &responseHeader) {

	// Save cookies
//	cout << "[DEBUG] TinIt - Detach cookies from http response" << endl;
	QList<QPair<QString, QString> > values = responseHeader.values();
	for(QList<QPair<QString ,QString> >::iterator i = values.begin(); i != values.end(); i++) {
		if((*i).first.compare("set-cookie") == 0) {
			_cookieManager->setCookie((*i).second);
		}
	}

	if(responseHeader.statusCode() == 302) {
		qDebug("[tin.it SMS] Response header received with status code 302 (Redirect)");
		QString location = responseHeader.value("Location");
		QString host = location.left(location.indexOf("/", 7)).remove(0,7);
		QHttpRequestHeader header("GET", location.remove(0,location.indexOf("/", 7)));
		header.setValue("Host", host);
		qHttp_->setHost(host);
		_attachCookies(&header);
		qHttp_->request(header);
		return;
	}

	if(responseHeader.statusCode() == 200) {
		qDebug("[tin.it SMS] Response header received with status code 200 (Ok)");
		qDebug("[tin.it SMS] End");
		return;
	}

	qDebug("[tin.it SMS] Response header received with status code ? (?)");

}

void kms::AliceItSmsServant::_attachCookies(QHttpRequestHeader *header) {
//	cout << "[DEBUG] TinItSms - Attach cookies to http request" << endl;
	QString cookieQString;
	bool flag = false;
	QList<Cookie> cookies = _cookieManager->getCookies();
	for(QList<Cookie>::iterator i = cookies.begin(); i != cookies.end(); i++) {
		QString name = (*i).getName();
		cookieQString.append((*i).getName() + "=" + (*i).getContent() + "; ");
		flag = true;
	}
	if(flag == true) {
		cookieQString.chop(2);
	}
	header->setValue("Cookie", cookieQString);
}

//void kms::TinItSmsServant::_slot_requestFinished(int id, bool error) {
//	_mainWindow->debugTextEdit->insertPlainText(QString(_qBuffer->data()));
//	_mainWindow->debugTextEdit->append(QString(_qBuffer->data()));
//}

//void kms::TinItSmsServant::_slot_qBufferReadyRead() {
//	_mainWindow->debugTextEdit->insertPlainText(QString(_qBuffer->data()));
//	_mainWindow->debugTextEdit->append(QString(_qBuffer->data()));
//}

void kms::AliceItSmsServant::_slot_done(bool error) {

	qDebug("slot_done!");

	QByteArray response = qHttp_->readAll();

	if(step==5) {

		file = new QFile(QDir::homePath() + "/.scrocksms/captcha.jpg");
		if(!file->open(QIODevice::WriteOnly)) {
			qDebug("Errore apertura file");
		} else {
			qDebug("File aperto in scrittura");
		}
		file->write(response);
		file->close();

		CaptchaManager *captchaManager = _mainWindow->getCaptchaManager();
		QString fileName1 = QDir::homePath() + "/.scrocksms/captcha.jpg";
//c TOLTO PERCHE' NON RICOMPILAVA!!!
//c		captchaManager->setCaptcha(fileName1);
		captchaManager->setVisible(true);

		bool ok;
		_captchaText = QInputDialog::getText(_mainWindow, tr("Captcha Input"), tr("Inserisci il codice che vedi nella finestra a fianco:"), QLineEdit::Normal, "", &ok);
	     	if (ok && !_captchaText.isEmpty()) {
	        	// ok...
		} else {
			// Wrong...
			_captchaText = "";
		}
	}

//	if(step == 6) {
//		_mainWindow->debugTextEdit->append(QString(response));
//		_mainWindow->debugTextEdit->setVisible(true);
//	}

	step++;
	_send();


}
