/*
 * aliceitsms.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_ALICEITSMS_H
#define KMS_ALICEITSMS_H

#include <QBuffer>
	#include <QFile>
#include "providers/provider.h"
#include "providers/servant.h"

namespace kms {

	class AliceItSms : public virtual Provider {

		public:
			AliceItSms();
			~AliceItSms();

			Servant *createServant(MainWindow *mainWindow);

	};

	class AliceItSmsServant : public Servant {

		Q_OBJECT

		public:
			AliceItSmsServant(MainWindow *mainWindow);
			~AliceItSmsServant();

			void run();

		private:
			void _send();
			QBuffer *_qBuffer;
			int _requestId;
			void _attachCookies(QHttpRequestHeader *header);
			int step;
			CookieManager *_cookieManager;
			QFile *file; // forse non usato (overloaded)
			QString _captchaText;

		private slots:
			void _slot_ResponseHeaderReceived(const QHttpResponseHeader &responseHeader);
//			void _slot_requestFinished(int id, bool error);
//			void _slot_qBufferReadyRead();
			void _slot_done(bool error);

	};


};

#endif
