/*
 * servant.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_SERVANT_H
#define KMS_SERVANT_H

#include <QHttp>
#include <QThread>

#include "account.h"
#include "message.h"
#include "mainwindow.h"
	#include "sources/core/enhancedqhttp/enhancedqhttp.h"
	using namespace kms;
namespace kms {

	class Account;
	class MainWindow;

	class Servant : public QThread {

		public:
			Servant(MainWindow *mainWindow);
			virtual ~Servant();

			virtual void run() = 0;

			void sendMessage(const Account *account, const Message &message);

		protected:
//AAA			QHttp *qHttp_;
			EnhancedQHttp *qHttp_;
			Account *account_;
			Message message_;
			MainWindow *_mainWindow;

		private:

	};

};

#endif
