/*
 * tinitsmsservant.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include <QByteArray>
#include <QHttpRequestHeader>
#include <QHttpResponseHeader>
#include <QString>
#include <QUrl>

#include "providers/tinitsmsservant.h"
	#include <QBuffer>
using namespace kms;

kms::TinItSmsServant::TinItSmsServant(MainWindow *mainWindow) : Servant(mainWindow), _requestId(0) {

//	_qBuffer = new QBuffer(this);
//	_qBuffer->open(QBuffer::ReadWrite);
//	_mainWindow->debugTextEdit->setVisible(true);

	connect(qHttp_, SIGNAL(responseHeaderReceived(const QHttpResponseHeader &)), this, SLOT(_slot_ResponseHeaderReceived(const QHttpResponseHeader &)));
//	connect(qHttp_, SIGNAL(requestFinished(int, bool)), this, SLOT(_slot_requestFinished(int, bool)));
	connect(qHttp_, SIGNAL(done(bool)), this, SLOT(_slot_done(bool)));
//	connect(_qBuffer, SIGNAL(readyRead()), this, SLOT(_slot_qBufferReadyRead()));
//	connect(qHttp_, SIGNAL(responseHeaderReceived(const QHttpResponseHeader &)), _mainWindow->getCaptchaManager(), SLOT(show()));
//	_mainWindow->getCaptchaManager()->setVisible(true);

	step = 1;
	_cookieManager = new CookieManager;


}

kms::TinItSmsServant::~TinItSmsServant() {
	// Does nothing...
//	_qBuffer->close();
//	delete _qBuffer;
	disconnect(qHttp_, 0, 0, 0);
	delete _cookieManager;
}

void kms::TinItSmsServant::run() {
	_send();
}

void kms::TinItSmsServant::_send() {

	if(step == 1) {
		qDebug("[DEBUG] TinIt - 1");
		QHttpRequestHeader header("POST", "/asp/a3login.asp");
		qHttp_->setHost("communicator.alice.it");
		header.setValue("Host", "communicator.alice.it");
		header.setValue("Content-Type","application/x-www-form-urlencoded");
		QStringList usernameParts = account_->getUsername().split("@");
		qHttp_->request(header, QByteArray(QString("usernameDisplay=" + usernameParts[0] + "&dominio=%40" + usernameParts[1] + "&password=" + account_->getPassword() + "&login=" + account_->getUsername() + "&pwd=" + account_->getPassword() + "&channel=hp_alice&URL_OK=http%3A%2F%2Fportale.rossoalice.alice.it%2Fps%2FPFSpallaDestra.do&URL_KO=http%3A%2F%2Fportale.rossoalice.alice.it%2Fps%2Fpages%2Ferror%2Fdx%2FSDUrlKo.jsp&URL_ERROR=http%3A%2F%2Fportale.rossoalice.alice.it%2Fps%2Fpages%2Ferror%2Fdx%2FSDUrlError.jsp&URL_PROV=http%3A%2F%2Fportale.rossoalice.alice.it%2Fps%2Fpages%2Ferror%2Falice%2FSDUrlProv.jsp&URL_RESERVED=http%3A%2F%2Fportale.rossoalice.alice.it%2Fps%2Fpages%2Ferror%2Falice%2FSDUrlReserved.jsp&URLERROR_SUSPENDED=http%3A%2F%2Fportale.rossoalice.alice.it%2Fps%2Fpages%2Ferror%2Falice%2FSDUrlSuspended.jsp+&URLERROR_INACTIVE=http%3A%2F%2Fportale.rossoalice.alice.it%2Fps%2Fpages%2Ferror%2Falice%2FSDUrlInactive.jsp+&servizio=mail&msisdn=" + usernameParts[0] + "&username=" + account_->getUsername() + "&user=" + account_->getUsername() + "&a3aid=comhpvi&a3afep=http%3A%2F%2Fmail.alice.it%2Fmail%2Fhome%2Ferrore_login.html&DOMAIN=" + usernameParts[1] + "&PASS=" + account_->getPassword() + "").toUtf8()));
		return;
	}

	if(step == 2) {
		qDebug("[DEBUG] TinIt - 2");
		QHttpRequestHeader header("POST", "/piattaformaAAA/controller/AuthenticationServlet");
		qHttp_->setHost("aaacsc.alice.it");
		header.setValue("Host", "aaacsc.alice.it");
		header.setValue("Content-Type", "application/x-www-form-urlencoded");
		_attachCookies(&header);
		qHttp_->request(header, QByteArray(QString("a3l=" + account_->getUsername() + "&a3p=" + account_->getPassword() + "&a3si=-1&percmig=100&a3st=VCOMM&a3aid=comhpvi&a3flag=0&a3ep=http%3A%2F%2Fcommunicator.virgilio.it%2Fasp%2Flogin.asp&a3afep=http%3A%2F%2Fcommunicator.virgilio.it%2Fasp%2Flogin.asp&a3se=http%3A%2F%2Fcommunicator.virgilio.it%2Fasp%2Flogin.asp&a3dcep=http%3A%2F%2Fcommunicator.virgilio.it%2Fasp%2Fhomepage.asp%3Fs%3D005").toUtf8()));
		return;
	}

	if(step == 3) {
		qDebug("[DEBUG] TinIt - 3");
		QHttpRequestHeader header("GET", "/supermail/controller");
		qHttp_->setHost("gsmailmdumail.virgilio.it", 8080);
		header.setValue("Host", "gsmailmdumail.virgilio.it:8080");
		_attachCookies(&header);
		qHttp_->request(header);
		return;
	}

	if(step == 4) {
		qDebug("[DEBUG] TinIt - 4");
		QHttpRequestHeader header("POST", "/supermail/controller?username=" + account_->getUsername() + "&action=sendsms");
		qHttp_->setHost("gsmailmdumail.virgilio.it", 8080);
		header.setValue("Host", "gsmailmdumail.virgilio.it:8080");
		header.setValue("Content-Type","application/x-www-form-urlencoded");
		_attachCookies(&header);
		qHttp_->request(header, QByteArray(QString("lista_operatori=x&numero=&select=x&recipient=%2B39"+ message_.getRecipient() +"&testo=" + message_.getText() + "").toUtf8()));
		return;
	}

	// The end is reached?
	if(step == 5) {
		_cookieManager->clearCookies();
		return;
	}

}

void kms::TinItSmsServant::_slot_ResponseHeaderReceived(const QHttpResponseHeader &responseHeader) {

	// Save cookies
//	cout << "[DEBUG] TinIt - Detach cookies from http response" << endl;
	QList<QPair<QString, QString> > values = responseHeader.values();
	for(QList<QPair<QString ,QString> >::iterator i = values.begin(); i != values.end(); i++) {
		if((*i).first.compare("set-cookie") == 0) {
			_cookieManager->setCookie((*i).second);
		}
	}

	if(responseHeader.statusCode() == 302) {
		qDebug("[tin.it SMS] Response header received with status code 302 (Redirect)");
		QString location = responseHeader.value("Location");
		QString host = location.left(location.indexOf("/", 7)).remove(0,7);
		QHttpRequestHeader header("GET", location.remove(0,location.indexOf("/", 7)));
		header.setValue("Host", host);
		qHttp_->setHost(host);
		_attachCookies(&header);
		qHttp_->request(header);
		return;
	}

	if(responseHeader.statusCode() == 200) {
		qDebug("[tin.it SMS] Response header received with status code 200 (Ok)");
		qDebug("[tin.it SMS] End");
		return;
	}

	qDebug("[tin.it SMS] Response header received with status code ? (?)");

}

void kms::TinItSmsServant::_attachCookies(QHttpRequestHeader *header) {
//	cout << "[DEBUG] TinItSms - Attach cookies to http request" << endl;
	QString cookieQString;
	bool flag = false;
	QList<Cookie> cookies = _cookieManager->getCookies();
	for(QList<Cookie>::iterator i = cookies.begin(); i != cookies.end(); i++) {
		QString name = (*i).getName();
		cookieQString.append((*i).getName() + "=" + (*i).getContent() + "; ");
		flag = true;
	}
	if(flag == true) {
		cookieQString.chop(2);
	}
	header->setValue("Cookie", cookieQString);
}

//void kms::TinItSmsServant::_slot_requestFinished(int id, bool error) {
//	_mainWindow->debugTextEdit->insertPlainText(QString(_qBuffer->data()));
//	_mainWindow->debugTextEdit->append(QString(_qBuffer->data()));
//}

//void kms::TinItSmsServant::_slot_qBufferReadyRead() {
//	_mainWindow->debugTextEdit->insertPlainText(QString(_qBuffer->data()));
//	_mainWindow->debugTextEdit->append(QString(_qBuffer->data()));
//}

void kms::TinItSmsServant::_slot_done(bool error) {
//	QByteArray response = qHttp_->readAll();
//	_mainWindow->debugTextEdit->insertPlainText(QString(response));
//	_mainWindow->debugTextEdit->append(QString(response));
	step++;
	_send();
}
