/*
 * tinitsmsservant.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_TINITSMSSERVANT_H
#define KMS_TINITSMSSERVANT_H

#include <QBuffer>
#include <QHttpResponseHeader>
#include <QObject>
#include <QThread>

#include "account.h"
#include "message.h"
#include "providers/servant.h"

namespace kms {

	class TinItSmsServant : public Servant {

		Q_OBJECT

		public:
			TinItSmsServant(MainWindow *mainWindow);
			~TinItSmsServant();

			void run();
	CookieManager *_cookieManager;
		private:
			void _send();
			QBuffer *_qBuffer;
			int _requestId;
		void _attachCookies(QHttpRequestHeader *header);
		int step;

		private slots:
			void _slot_ResponseHeaderReceived(const QHttpResponseHeader &responseHeader);
//			void _slot_requestFinished(int id, bool error);
//			void _slot_qBufferReadyRead();
			void _slot_done(bool error);

	};

};

#endif
