/*
 * vodafoneitmms.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include <QByteArray>
#include <QRegExp>
#include <QString>
#include <QUrl>

#include "providers/vodafoneitmms.h"

using namespace kms;

kms::VodafoneItMms::VodafoneItMms() {

	setName(QString("vodafone.it mms"));

// DEF	setAcceptsSender(false);
	setAcceptsRecipient(true);
	setAcceptsSubject(true);
	setAcceptsText(true);

// DEF	setMaxSenderLenght(-1);
// DEF	setMaxRecipientLenght(-1);
// DEF	setMaxSubjectLenght(-1);
// DEF	setMaxTextLenght(-1);

// DEF	setSenderRegExp(QRegExp(".*"));
	setRecipientRegExp(QRegExp("[1-9]\\d{9}"));	// "(\\+|00)?[1-9]\\d*"
// DEF	setSubjectRegExp(QRegExp(".*"));
// DEF	setTextRegExp(QRegExp(".*"));

}

kms::VodafoneItMms::~VodafoneItMms() {
	// Does nothing...
}

kms::Servant *VodafoneItMms::createServant(MainWindow *mainWindow) {
	return new VodafoneItMmsServant(mainWindow);
}

kms::VodafoneItMmsServant::VodafoneItMmsServant(MainWindow *mainWindow) : Servant(mainWindow) {
	connect(qHttp_, SIGNAL(done(bool)), this, SLOT(_slot_done(bool)));
}

kms::VodafoneItMmsServant::~VodafoneItMmsServant() {
	disconnect(qHttp_, 0, 0, 0);
}

void kms::VodafoneItMmsServant::run() {
	_send();
}

void kms::VodafoneItMmsServant::_send() {
	QHttpRequestHeader header("POST", "/WebComposer/web/elaborapop.jsp");
	qHttp_->setHost("mmsviaweb.net.vodafone.it");
	header.setValue("Host", "mmsviaweb.net.vodafone.it");
	header.setValue("Content-Type", "application/x-www-form-urlencoded");
	qHttp_->request(header, QByteArray(QString("subjecttosend=").toUtf8() + QUrl::toPercentEncoding(QUrl::toPercentEncoding(message_.getSubject())) + QString("&TextName=" + message_.getText() + "&recipient=%2B39" + QUrl::toPercentEncoding(message_.getRecipient()) + "&SmilName=&ImageName=&AudioName=").toUtf8()));
}

void kms::VodafoneItMmsServant::_slot_done(bool error) {
	QByteArray response = qHttp_->readAll();
	_mainWindow->debugTextEdit->append(QString(response));
	_mainWindow->debugTextEdit->setVisible(true);
}
