/*
 * vodafoneitmms.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_VODAFONEITMMS_H
#define KMS_VODAFONEITMMS_H

#include "providers/provider.h"
#include "providers/servant.h"

namespace kms {

	class VodafoneItMms : public virtual Provider {

		public:
			VodafoneItMms();
			~VodafoneItMms();

			Servant *createServant(MainWindow *mainWindow);

	};

	class VodafoneItMmsServant : public Servant {

		Q_OBJECT

		public:
			VodafoneItMmsServant(MainWindow *mainWindow);
			~VodafoneItMmsServant();

			void run();

		private:
			void _send();

		private slots:
			void _slot_done(bool error);

	};

};

#endif
