/*
 * vodafoneitsms.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include <QRegExp>
#include <QString>

#include "providers/vodafoneitsms.h"
#include "providers/vodafoneitsmsservant.h"

using namespace kms;

kms::VodafoneItSms::VodafoneItSms() {

	setName(QString("vodafone.it sms"));

	setAcceptsSender(true);
	setAcceptsRecipient(true);
	setAcceptsSubject(false);
	setAcceptsText(true);

// DEF	setMaxSenderLenght(-1);
// DEF	setMaxRecipientLenght(-1);
// DEF	setMaxSubjectLenght(-1);
// DEF	setMaxTextLenght(-1);

	setSenderRegExp(QRegExp("[1-9]\\d{9}"));
	setRecipientRegExp(QRegExp("[1-9]\\d{9}"));	// "(\\+|00)?[1-9]\\d*"
// DEF	setSubjectRegExp(QRegExp(".*"));
// DEF	setTextRegExp(QRegExp(".*"));

}

kms::VodafoneItSms::~VodafoneItSms() {
	// Does nothing...
}

Servant *kms::VodafoneItSms::createServant(MainWindow *mainWindow) {
	return new VodafoneItSmsServant(mainWindow);
}
