/*
 * vodafoneitsmsservant.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include <QByteArray>
#include <QHttpRequestHeader>
#include <QHttpResponseHeader>
#include <QString>
#include <QUrl>
		#include <QDir>
		#include <QFile>
		#include <QInputDialog>
#include "providers/vodafoneitsmsservant.h"
	#include <QBuffer>
using namespace kms;

kms::VodafoneItSmsServant::VodafoneItSmsServant(MainWindow *mainWindow) : Servant(mainWindow), _requestId(0) {

	_cookieManager = new CookieManager;

	_qBuffer = new QBuffer(this);
	_qBuffer->open(QBuffer::ReadWrite);
//	_mainWindow->debugTextEdit->setVisible(true);

	connect(qHttp_, SIGNAL(responseHeaderReceived(const QHttpResponseHeader &)), this, SLOT(_slot_ResponseHeaderReceived(const QHttpResponseHeader &)));
	connect(qHttp_, SIGNAL(requestFinished(int, bool)), this, SLOT(_slot_requestFinished(int, bool)));
	connect(qHttp_, SIGNAL(done(bool)), this, SLOT(_slot_done(bool)));
	connect(_qBuffer, SIGNAL(readyRead()), this, SLOT(_slot_qBufferReadyRead()));
//	connect(qHttp_, SIGNAL(responseHeaderReceived(const QHttpResponseHeader &)), _mainWindow->getCaptchaManager(), SLOT(show()));
//	_mainWindow->getCaptchaManager()->setVisible(true);

	_step = 1;

	file = new QFile(QDir::homePath() + "/.scrocksms/captcha.jpg");
	if(!file->open(QIODevice::WriteOnly)) {
		qDebug("Errore apertura file");
	} else {
		qDebug("File aperto in scrittura");
	}


}

kms::VodafoneItSmsServant::~VodafoneItSmsServant() {
	// Does nothing...
	_qBuffer->close();
	delete _qBuffer;
	disconnect(qHttp_, 0, 0, 0);
	delete _cookieManager;
}

void kms::VodafoneItSmsServant::run() {
	_send();
}

void kms::VodafoneItSmsServant::_send() {

	if(_step == 1) {
		qDebug("[vodafone.it SMS] 1");
		QHttpRequestHeader header("POST", "/190/trilogy/jsp/login.do");
		qHttp_->setHost("www.190.it");
		header.setValue("Host", "www.190.it");
		header.setValue("Content-Type","application/x-www-form-urlencoded");
		_attachCookies(&header);
		qHttp_->request(header, QByteArray(QString("username=pietro.spinella82&password=balena17&login_button.x=19&login_button.y=4").toUtf8()), _qBuffer);
	}

	if(_step == 2) {
		qDebug("[vodafone.it SMS] 2");
		QHttpRequestHeader header("GET", "/190/trilogy/jsp/homePage.do?tabName=Fai+da+te+privati");
		qHttp_->setHost("www.areaprivati.190.it");
		header.setValue("Host", "www.areaprivati.190.it");
		_attachCookies(&header);
		qHttp_->request(header, 0, _qBuffer);
	}

	if(_step == 3) {
		qDebug("[vodafone.it SMS] 3");
		QHttpRequestHeader header("GET", "/190/trilogy/jsp/swapSim.do?tk=9604,l&ty_sim=" + message_.getSender() + "");
		qHttp_->setHost("www.areaprivati.190.it");
		header.setValue("Host", "www.areaprivati.190.it");
		_attachCookies(&header);
		qHttp_->request(header, 0, _qBuffer);
	}

	if(_step == 0) {
		qDebug("[vodafone.it SMS] 4");
		QHttpRequestHeader header("GET", "/190/trilogy/jsp/home.do?tabName=Fai+da+te+privati&ty_nocache=true");
		qHttp_->setHost("www.areaprivati.190.it");
		header.setValue("Host", "www.areaprivati.190.it");
		_attachCookies(&header);
		qHttp_->request(header, 0, _qBuffer);
	}

	if(_step == 4) {
		qDebug("[vodafone.it SMS] 5a");
		QHttpRequestHeader header("GET", "/190/trilogy/jsp/programView.do?ty_program_page=%2fprecheck.do&channelId=-18126&ty_target_type=1&pageTypeId=9604&programId=10384&ty_program_ctx=%2ffsms&ty_nocache=true&tk=9604,t&ty_op=-3,-1,-19604,1,-1,-1");
		qHttp_->setHost("www.areaprivati.190.it");
		header.setValue("Host", "www.areaprivati.190.it");
		_attachCookies(&header);
		qHttp_->request(header, 0, _qBuffer);
	}

	if(_step == 0) {
	_step++;
	}

	if(_step == 5) {
		qDebug("[vodafone.it SMS] 6");
		QHttpRequestHeader header("GET", "/190/trilogy/jsp/programPage.do?ty_key=fsms_hp&ty_program_page=%2fprecheck.do&channelId=-18126&ty_target_type=1&pageTypeId=9604&ipage=next&programId=10384&ty_program_ctx=%2ffsms&ty_nocache=true");
		qHttp_->setHost("www.areaprivati.190.it");
		header.setValue("Host", "www.areaprivati.190.it");
		_attachCookies(&header);
		qHttp_->request(header, 0, _qBuffer);
	}


	if(_step == 6) {
		qDebug("[vodafone.it SMS] 7");
		QHttpRequestHeader header("POST", "/190/fsms/prepare.do");
		qHttp_->setHost("www.areaprivati.190.it");
		header.setValue("Host", "www.areaprivati.190.it");
		header.setValue("Content-Type","application/x-www-form-urlencoded");
		_attachCookies(&header);
		qHttp_->request(header, QByteArray(QString("pageTypeId=9604&programId=10384&channelId=-18126&receiverNumber=" + message_.getRecipient() + "&message=" + message_.getText() + "&availableChars=360&x=22&y=8").toUtf8()), _qBuffer);
	}

	if(_step == 7) {
		qDebug("[vodafone.it SMS] 8");
		QHttpRequestHeader header("GET", "/190/fsms/generateimg.do");
		header.setValue("Accept", "image/png,*/*;q=0.5");
		header.setValue("Accept-Language", "en-us,en;q=0.5");
		header.setValue("Accept-Charset", "ISO-8859-1,utf-8;q=0.7,*;q=0.7");
		qHttp_->setHost("www.areaprivati.190.it", QHttp::ConnectionModeHttps);
		header.setValue("Host", "www.areaprivati.190.it");
		header.setValue("Content-Type","application/x-www-form-urlencoded");
		_attachCookies(&header);
//		qHttp_->get("/190/fsms/generateimg.do", file);
		qHttp_->request(header, 0, file);
//		qHttp_->request(header, 0, _qBuffer);

	}

	if(_step == 8) {
		qDebug("[vodafone.it SMS] 9");
		QHttpRequestHeader header("POST", "/190/fsms/send.do");
		qHttp_->setHost("www.areaprivati.190.it");
		header.setValue("Host", "www.areaprivati.190.it");
		header.setValue("Content-Type","application/x-www-form-urlencoded");
		_attachCookies(&header);
		qHttp_->request(header, QByteArray(QString("pageTypeId=9604&programId=10384&channelId=-18126&receiverNumber=" + message_.getRecipient() + "&message=" + message_.getText() + "&verifyCode=" + _captchaText + "&x=21&y=7").toUtf8()), _qBuffer);
	}

}

void kms::VodafoneItSmsServant::_attachCookies(QHttpRequestHeader *header) {
//	qDebug("[vodafone.it SMS] Attach cookies to http request");
	QString cookieQString;
	bool flag = false;
	QList<Cookie> cookies = _cookieManager->getCookies();
	for(QList<Cookie>::iterator i = cookies.begin(); i != cookies.end(); i++) {
		QString name = (*i).getName();
		cookieQString.append((*i).getName() + "=" + (*i).getContent() + "; ");
		flag = true;
	}
	if(flag == true) {
		cookieQString.chop(2);
	}
	header->setValue("Cookie", cookieQString);
}


void kms::VodafoneItSmsServant::_slot_ResponseHeaderReceived(const QHttpResponseHeader &responseHeader) {

//	_mainWindow->debugTextEdit->insertPlainText("- - - PAGE - - -\n");
//	_mainWindow->debugTextEdit->insertPlainText(QString(_qBuffer->data()));
//	_mainWindow->debugTextEdit->append(QString(_qBuffer->data()));

	// Save cookies
//	qDebug("[vodafone.it SMS] Detach cookies from http response");
	QList<QPair<QString, QString> > values = responseHeader.values();
	for(QList<QPair<QString ,QString> >::iterator i = values.begin(); i != values.end(); i++) {
		if((*i).first.compare("set-cookie") == 0) {
			_cookieManager->setCookie((*i).second);
		}
	}

	if(responseHeader.statusCode() == 302) {
		qDebug("[vodafone.it SMS] Response header received with status code 302 (Redirect)");
		QString location = responseHeader.value("Location");
		QString host = location.left(location.indexOf("/", 7)).remove(0,7);
		QHttpRequestHeader header("GET", location.remove(0,location.indexOf("/", 7)));
		header.setValue("Host", host);
		qHttp_->setHost(host);
		header.setValue("User-Agent", "Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.6) Gecko/20061201 Firefox/2.0.0.6 (Ubuntu-feisty)");
		header.setValue("Accept", "text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5");
		header.setValue("Accept-Language", "it-it,it;q=0.8,en-us;q=0.5,en;q=0.3");
//		header.setValue("Accept-Encoding", "gzip,deflate");
		header.setValue("Accept-Charset", "ISO-8859-1,utf-8;q=0.7,*;q=0.7");
		header.setValue("Keep-Alive", "300");
		header.setValue("Connection", "keep-alive");
		_attachCookies(&header);
		qHttp_->request(header);
		return;
	}

	if(responseHeader.statusCode() == 200) {
		qDebug("[vodafone.it SMS] Response header received with status code 200 (Ok)");
		return;
	}

	qDebug("[vodafone.it SMS] Response header received with status code ? (?)");

}

void kms::VodafoneItSmsServant::_slot_requestFinished(int id, bool error) {
//	_mainWindow->debugTextEdit->insertPlainText(QString(_qBuffer->data()));
//	_mainWindow->debugTextEdit->append(QString(_qBuffer->data()));
}

void kms::VodafoneItSmsServant::_slot_qBufferReadyRead() {

//--	_mainWindow->debugTextEdit->insertPlainText(QString(_qBuffer->data()));

     	if(_step>=8) {
		_mainWindow->debugTextEdit->append(QString(_qBuffer->data()));
		return;
	}

/*
	if(_step==7) {
		QString fileName1 = "/media/sda1/Documents and Settings/pentium IV/Desktop/foto/Immagine 217.jpg";
		CaptchaManager *captchaManager = _mainWindow->getCaptchaManager();
		QFile file(QDir::homePath() + "/.scrocksms/test.png");
		if(file.open(QIODevice::WriteOnly)==true) {
			QDataStream qDataStream(&file);
			file.close();
		}
		captchaManager->setCaptcha(fileName1);
		captchaManager->setVisible(true);
		return;
	}
*/

	_qBuffer->data();

}

void kms::VodafoneItSmsServant::_slot_done(bool error) {

	qDebug("slot_done!");

	QByteArray response = qHttp_->readAll();

	if(_step==7) {
		file->write(response);
		file->close();
		CaptchaManager *captchaManager = _mainWindow->getCaptchaManager();
		QString fileName1 = QDir::homePath() + "/.scrocksms/captcha.jpg";
//c TOLTO PERCHE' NON COMPILAVA!
//c		captchaManager->setCaptcha(fileName1);
//		captchaManager->setWindowModality(Qt:Modal);
		captchaManager->setVisible(true);

		bool ok;
		_captchaText = QInputDialog::getText(_mainWindow, tr("Captcha Input"), tr("Inserisci il codice che vedi nella finestra a fianco:"), QLineEdit::Normal, "", &ok);
	     	if (ok && !_captchaText.isEmpty()) {
	        	// ok...
		} else {
			// Wrong...
			_captchaText = "";
		}
	}

//	if(_step>=8) {
//		_mainWindow->debugTextEdit->insertPlainText(QString(response));
//	}

	_step++;
	_send();

}
