/*
 * scheduler.h
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#ifndef KMS_SCHEDULER_H
#define KMS_SCHEDULER_H

#include <QList>
#include <QThread>

#include "job.h"
#include "mainwindow.h"

namespace kms {
class Job;
	class MainWindow;

	class Scheduler : public QThread {

		public:
			Scheduler(QObject *parent = 0);
			~Scheduler();

			void enqueueJob(const Job &job);

			bool isAlive;

		protected:
			void run();

		private:
			QList<Job> _jobs;
			bool _isWorking;
			MainWindow *_mainWindow;

	};

};

#endif
