/*
 * scheduleritemdelegate.cpp
 *
 * @author Pietro Spinella (scrockman[at]gmail[dot]com)
 * @license GPLv3
 */

#include "scheduleritemdelegate.h"

using namespace kms;

// TEST
#include <QProgressBar>
#include <QWidget>
// TEST

kms::SchedulerItemDelegate::SchedulerItemDelegate(QObject *parent) : QItemDelegate(parent) {

	// Does Nothing...

}

QWidget *kms::SchedulerItemDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem & /* option */, const QModelIndex &index) const {

	QLineEdit *lineEdit;
//	QComboBox *comboBox;
	QProgressBar *progressBar;

	QPushButton *button1;
	QPushButton *button2;
	QHBoxLayout *layout;
	QWidget *window;

	switch(index.column()) {
		// Status
		case 0:
			progressBar = new QProgressBar(parent);
			progressBar->setAlignment(Qt::AlignHCenter);
/*
window = new QWidget(parent);
button1 = new QPushButton("Stop");
button2 = new QPushButton("Resend");
layout = new QHBoxLayout;
layout->addWidget(button1);
layout->addWidget(button2);
layout->addWidget(progressBar);
window->setLayout(layout);
*/
			return progressBar;
		// Recipient
		case 1:
			lineEdit = new QLineEdit(parent);
			lineEdit->setReadOnly(true);
			return lineEdit;
		// Text
		case 2:
			lineEdit = new QLineEdit(parent);
			lineEdit->setReadOnly(true);
			return lineEdit;
		// Default
		default:
			return new QWidget();
	}

//	connect(comboBox, SIGNAL(activated(int)), this, SLOT(emitCommitData()));

}

void kms::SchedulerItemDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const {

	QLineEdit *lineEdit;
//	QComboBox *comboBox;
	QProgressBar *progressBar;
	QString value;
	QVariant value2;
//	int pos;

	switch(index.column()) {
		// Status
		case 0:
			progressBar = qobject_cast<QProgressBar *>(editor);
			progressBar->setAlignment(Qt::AlignHCenter);
//			value2 = index.model()->data(index, Qt::DisplayRole);
//			progressBar->setValue(value2.toInt());
			break;
		// Recipient
		case 1:
			lineEdit = qobject_cast<QLineEdit *>(editor);
			value = index.model()->data(index, Qt::DisplayRole).toString();
			lineEdit->setText(value);
			break;
		// Text
		case 2:
			lineEdit = qobject_cast<QLineEdit *>(editor);
			value = index.model()->data(index, Qt::DisplayRole).toString();
			lineEdit->setText(value);
			break;
		default:
			break;
	}

}

void kms::SchedulerItemDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const {

//	QComboBox *comboBox;
	QLineEdit *lineEdit;
	QProgressBar *progressBar;

	switch(index.column()) {
		// Status
		case 0:
			progressBar = qobject_cast<QProgressBar *>(editor);
			model->setData(index, progressBar->value());
			break;
		// Recipient
		case 1:
			lineEdit = qobject_cast<QLineEdit *>(editor);
			model->setData(index, lineEdit->text());
			break;
		// Text
		case 2:
			lineEdit = qobject_cast<QLineEdit *>(editor);
			model->setData(index, lineEdit->text());
			break;
		// Default
		default:
			break;
	}

}

void kms::SchedulerItemDelegate::emitCommitData() {

	emit commitData(qobject_cast<QWidget *>(sender()));

}
