/*
 * crazyalgorithm.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail.com)
 * $license GPLv3
 */

#include "crazyalgorithm.h"

using namespace kms;

kms::CrazyAlgorithm::CrazyAlgorithm()
{
	// Create and set the SmartAlgorithm and ElegantAlgorithm
	_smartAlgorithm = new SmartAlgorithm;
	_elegantAlgorithm = new ElegantAlgorithm;
}

kms::CrazyAlgorithm::~CrazyAlgorithm()
{
	// Deletes the SmartAlgorithm and ElegantAlgorithm
	delete _smartAlgorithm;
	delete _elegantAlgorithm;
}

QString kms::CrazyAlgorithm::pack(const QString &text) const
{
	return _elegantAlgorithm->pack(_smartAlgorithm->pack(text));
}
