/*
 * crazyalgorithm.h
 *
 * $author Pietro Spinella (pietro.spinella@gmail.com)
 * $license GPLv3
 */

#ifndef KMS_CRAZYALGORITHM_H
#define KMS_CRAZYALGORITHM_H

#include <QString>

#include "packingalgorithm.h"
#include "smartalgorithm.h"
#include "elegantalgorithm.h"

namespace kms
{
	class CrazyAlgorithm : public PackingAlgorithm
	{
		public:
			// Constructs a CrazyAlgorithm.
			CrazyAlgorithm();
			// Destroys the CrazyAlgorithm.
			~CrazyAlgorithm();

			// Implements the abstract pack method of packingalgorithm.h.
			QString pack(const QString &text) const;

		private:
			// Stores the SmartAlgorithm and ElegantAlgorithm.
			SmartAlgorithm *_smartAlgorithm;
			ElegantAlgorithm *_elegantAlgorithm;
	};
};

#endif
