/*
 * elegantalgorithm.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail.com)
 * $license GPLv3
 */

#include <QRegExp>
#include <QStringList>

#include "elegantalgorithm.h"

using namespace kms;

kms::ElegantAlgorithm::ElegantAlgorithm()
{
	// Do nothing...
}

kms::ElegantAlgorithm::~ElegantAlgorithm()
{
	// Do nothing...
}

QString kms::ElegantAlgorithm::pack(const QString &text) const
{
	// Stores the result
	QString result;

	// Split the text in many words
	QStringList stringList = text.trimmed().split(QRegExp(" +"));
	QString currentString;
	int currentStringLenght;
	bool lastCharLowerFlag = true;	// [IT] Inizialmente minuscolo per scrivere maiuscolo!

	for(int i = 0; i < stringList.size(); i++)
	{
		currentString = stringList[i].trimmed();
		currentStringLenght = currentString.size();

		// [IT] Se la parola e' formata da piu' di una lettera...
		if(currentStringLenght > 1) {
			// [IT] Metti la prima lettera della parola maiuscola o minuscola...
			QString charAsString = "" + currentString[0];
			if(lastCharLowerFlag == true) {
				result += charAsString.toUpper();
			} else {
				result += charAsString.toLower();
			}
			// [IT] Metti la restante parte della parola (esclusa la prima lettere gia' messa)...
			result += currentString.left(currentStringLenght).right(currentStringLenght - 1);
			if(("" + currentString[currentStringLenght - 2]) == ("" + currentString[currentStringLenght - 2]).toLower()) {
				lastCharLowerFlag = true;
			} else {
				lastCharLowerFlag = false;
			}

		// [IT] Se la parola e' formata da una lettera...
		} else	if(currentStringLenght == 1) {
			// [IT] Inserisci la parola maiuscola o minuscola a seconda della lettera precedente...
			if(lastCharLowerFlag==true) {
				result += currentString.toUpper();
				lastCharLowerFlag = false;
			} else {
				result += currentString.toLower();
				lastCharLowerFlag = true;
			}
		}
	}

	// Return the result
	return result;
}
