/*
 * simplealgorithm.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail.com)
 * $license GPLv3
 */

#include "simplealgorithm.h"

using namespace kms;

kms::SimpleAlgorithm::SimpleAlgorithm() : _dictionary(0)
{
	// Do nothing...
}

kms::SimpleAlgorithm::SimpleAlgorithm(QList< QPair<QString, QString> > *dictionary) : _dictionary(dictionary)
{
	// Do nothing...
}

kms::SimpleAlgorithm::~SimpleAlgorithm()
{
	// Do nothing...
}

void kms::SimpleAlgorithm::setDictionary(QList< QPair<QString, QString> > *dictionary)
{
	_dictionary = dictionary;
}

QString kms::SimpleAlgorithm::pack(const QString &text) const
{
	if(_dictionary == 0)
	{
		return text;
	}

	QString result = text;

	for(QList<QPair<QString, QString> >::iterator i = _dictionary->begin(); i != _dictionary->end(); i++) {
		result.replace((*i).first, (*i).second);
	}

	return result;
}
