/*
 * smartalgorithm.cpp
 *
 * $author Pietro Spinella (pietro.spinella@gmail.com)
 * $license GPLv3
 */

#include <QRegExp>
#include <QStringList>

#include "smartalgorithm.h"

using namespace kms;

kms::SmartAlgorithm::SmartAlgorithm()
{
	// Do nothing...
}

kms::SmartAlgorithm::~SmartAlgorithm()
{
	// Do nothing...
}

QString kms::SmartAlgorithm::pack(const QString &text) const
{
	// Stores the result
	QString result;

	QStringList stringList = text.trimmed().split(QRegExp("\\s+"));
	QString currentString;
	int currentStringLenght;

	for(int i = 0; i < stringList.size(); i++)
	{
		currentString = stringList[i];
		currentStringLenght = currentString.size();
		QChar charTmp;

		// Remove the final vowel if it exists
		if(currentStringLenght > 1) {
			charTmp = currentString[currentStringLenght - 1];
			if(charTmp == 'a' || charTmp == 'e' || charTmp == 'i' || charTmp == 'o' || charTmp == 'u' || charTmp == 'A' || charTmp == 'E' || charTmp == 'I' || charTmp == 'O' || charTmp == 'U') {
				charTmp = currentString[currentStringLenght - 2];
				// Note: italian-dependent
				if(charTmp != 'a' && charTmp != 'e' && charTmp != 'i' && charTmp != 'o' && charTmp != 'u' && charTmp != 'h' && charTmp != 'A' && charTmp != 'E' && charTmp != 'I' && charTmp != 'O' && charTmp != 'U' && charTmp != 'H') {
					currentString = currentString.left(currentStringLenght - 1);
				}
			}
		}

		result += currentString + " ";
	}

	// Return the result
	return result.left(result.size() - 1);
}
